/*
Copyright (c) 2011, Julian Lyndon-Smith (julian+maia@dotr.com)
http://www.dotr.com
All rights reserved.

Permission is hereby granted, free of charge, to any person
obtaining a copy of this software and associated documentation
files (the "Software"), to deal in the Software without
restriction except as noted below, including without limitation
the rights to use,copy, modify, merge, publish, distribute,
and/or sublicense, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

 The Software and/or source code cannot be copied in whole and
 sold without meaningful modification for a profit.

 The above copyright notice and this permission notice shall be
 included in all copies or substantial portions of the Software.

 Redistributions of source code must retain the above copyright
 notice, this list of conditions and the following disclaimer.

 Redistributions in binary form must reproduce the above copyright
 notice, this list of conditions and the following disclaimer in
 the documentation and/or other materials provided with
 the distribution.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.
*/

using Progress.Lang.*.

/** Maia session properties 
 * @author Julian Lyndon-Smith (julian+maia@dotr.com) 
 */

routine-level on error undo, throw.

class dotr.Maia.CurrentProject:
  def public static property Name as char no-undo get . private set . 
  def public static property Path as char no-undo get . private set . 

  def public static property ConfigDirectory as char no-undo 
    get():
      return substitute("&1/_Maia-Config",Path).
    end get. private set. 

  def public static property TemplateDirectory as char no-undo 
    get():
      return substitute("&1/_Maia-Template",Path).
    end get. private set. 

  
  method public static void SetProject(p_Project as char,p_Path as char):
    if p_Project eq ? or p_Project eq "" then undo, throw new AppError("Project cannot be blank or unknown",0).
      
    assign name = p_project
           Path = p_Path.
  end method.
  
  method public static char GetConfigFile(p_ClassName as char):
    def var lv_dir as char no-undo.
    
    assign lv_dir = substitute("&1/&2",ConfigDirectory,p_ClassName).
    
    assign file-info:file-name = lv_dir. /** get class directory */

    if file-info:full-pathname eq ? then os-create-dir value(lv_dir). 
 
    return substitute("&1/_Config.xml",lv_Dir).
  end method.
  
end class.