
using Progress.Lang.*.

/*routine-level on error undo, throw.*/

class dotr.Maia.Model.fkModel: 
  /** temptable for fk defs */
  def temp-table tt-fk no-undo serialize-name "ForeignKeys"
    field ClassName as char
    field fkClassName as char 
    field type as char
    
    index ClassName is primary unique
      ClassName
      fkClassName
      type
		
    index fkObject is unique
      fkClassName
      ClassName
      type
      
    index ObjectType 
      ClassName
      type
      
    index fkObjectType 
      fkClassName
      type.

/** dataset so that we can read and write xml */          
  def dataset dsForeignKeys xml-node-name "Data" for tt-fk.
      		
	constructor public fkModel (  ):
	  def var lv_data as longchar no-undo.
		super ().
		
		empty temp-table tt-fk.
		
		copy-lob from file search(substitute("&1/ForeignKeys.xml",dotr.Maia.CurrentProject:ConfigDirectory)) to lv_Data no-error.

		if error-status:num-messages eq 0 then dataset dsForeignKeys:read-xml("longchar",lv_data,"empty",?,?).

	end constructor.
	
	method public void Addfk(p_ForeignObject as char,p_Object as char,p_type as char):
	  if can-find(tt-fk where tt-fk.fkClassName eq p_ForeignObject
	                      and tt-fk.ClassName   eq p_Object
	                      and tt-fk.Type         eq p_Type ) then return.

    create tt-fk.
    assign tt-fk.fkClassName = p_ForeignObject
           tt-fk.ClassName   = p_Object
           tt-fk.Type         = p_Type.
           
  end method.

  method public void Removefk(p_Object as char):
    for each tt-fk where tt-fk.ClassName eq p_Object:
      delete tt-fk.
    end.
  end method.

  method public void Removefktye(p_ForeignObject as char,p_Object as char,p_type as char):
    find tt-fk where tt-fk.fkClassName eq p_ForeignObject
                 and tt-fk.ClassName   eq p_Object 
                 and tt-fk.type         eq p_type no-error.

    if not avail tt-fk then return.
    
    delete tt-fk.

  end method.

  method public char extent Getfk(p_ForeignObject as char,p_Type as char):
    def var lv_Model as char extent no-undo.
    
    def var lv_i as int no-undo.
    
    for each tt-fk where tt-fk.fkClassName eq p_ForeignObject 
                     and tt-fk.type         eq p_Type no-lock lv_i = 1 to lv_i + 1:
    end.
    
    if lv_i eq 0 then 
    do:
     extent(lv_model) = 1.
     return lv_model.
    end.
    
    extent(lv_model) = lv_i.
    
    for each tt-fk where tt-fk.fkClassName eq p_ForeignObject 
                     and tt-fk.type         eq p_Type no-lock lv_i = 1 to lv_i + 1:
      lv_Model[lv_i] = tt-fk.ClassName.
    end.
    
    return lv_model.

  end method.

  method public char extent GetObject(p_Object as char,p_type as char):
    def var lv_Model as char extent no-undo.
    
    def var lv_i as int no-undo.
    
    for each tt-fk where tt-fk.ClassName eq p_Object 
                     and tt-fk.type         eq p_Type no-lock lv_i = 1 to lv_i + 1:
    end.
    
    if lv_i eq 0 then 
    do:
     extent(lv_model) = 1.
     return lv_model.
    end.
    
    extent(lv_model) = lv_i.
    
    for each tt-fk where tt-fk.ClassName eq p_Object 
                     and tt-fk.type         eq p_Type no-lock lv_i = 1 to lv_i + 1:
      lv_Model[lv_i] = tt-fk.fkClassName.
    end.
    
    return lv_model.

  end method.

  method public void Save():
    def var lv_Data as longchar no-undo.
    
    dataset dsForeignKeys:write-xml("longchar",lv_Data,yes).
    
    copy-lob from lv_Data to file substitute("&1/ForeignKeys.xml",dotr.Maia.CurrentProject:ConfigDirectory).
    
  end method.
         
    
end class.