&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v9r12 GUI
&ANALYZE-RESUME
&Scoped-define WINDOW-NAME CURRENT-WINDOW
&Scoped-define FRAME-NAME Dialog-Frame

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DECLARATIONS Dialog-Frame 

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS Dialog-Frame 
/*
Copyright (c) 2011, Julian Lyndon-Smith (julian+maia@dotr.com)
http://www.dotr.com
All rights reserved.

Permission is hereby granted, free of charge, to any person
obtaining a copy of this software and associated documentation
files (the "Software"), to deal in the Software without
restriction except as noted below, including without limitation
the rights to use,copy, modify, merge, publish, distribute,
and/or sublicense, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

 The Software and/or source code cannot be copied in whole and
 sold without meaningful modification for a profit.

 The above copyright notice and this permission notice shall be
 included in all copies or substantial portions of the Software.

 Redistributions of source code must retain the above copyright
 notice, this list of conditions and the following disclaimer.

 Redistributions in binary form must reproduce the above copyright
 notice, this list of conditions and the following disclaimer in
 the documentation and/or other materials provided with
 the distribution.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.
*/

&IF DEFINED(UIB_IS_RUNNING) eq 0 &THEN
def input parameter p_Template as dotr.Maia.Model.Template no-undo.
&ELSE
def var p_Template as dotr.Maia.Model.Template no-undo.
p_Template = new dotr.Maia.Model.Template().
&ENDIF

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE DIALOG-BOX
&Scoped-define DB-AWARE no

/* Name of designated FRAME-NAME and/or first browse and/or first query */
&Scoped-define FRAME-NAME Dialog-Frame

/* Standard List Definitions                                            */
&Scoped-Define ENABLED-OBJECTS RECT-7 fillin_template Toggle_Buildtemplate ~
Toggle_Exists TOGGLE-1 Button_Save Btn_Cancel 
&Scoped-Define DISPLAYED-OBJECTS fillin_template Toggle_Buildtemplate ~
Toggle_Exists TOGGLE-1 

/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */
&Scoped-define List-3 fillin_template 

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME


/* ************************  Function Prototypes ********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD StartUp Dialog-Frame 
function StartUp returns logical () forward.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD VerifyData Dialog-Frame 
function VerifyData returns logical
  ( )  forward.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* ***********************  Control Definitions  ********************** */

/* Define a dialog box                                                  */

/* Definitions of the field level widgets                               */
define button Btn_Cancel auto-end-key 
     label "Cancel" 
     context-help-id 2415
     size 15 by 1.14 tooltip "ContextDone"
     bgcolor 8 .

define button Button_Save auto-go 
     label "&Save" 
     context-help-id 2414
     size 15 by 1.14 tooltip "&Save"
     bgcolor 8 .

define variable fillin_template as character format "x(120)" 
     label "&Template Name" 
     context-help-id 2413
     view-as fill-in native 
     size 49 by 1.

define rectangle RECT-7
     edge-pixels 2 graphic-edge  no-fill   
     size 69 by 4.76.

define variable TOGGLE-1 as logical initial no 
     label "Rebuild target file even if MD5 has not changed" 
     view-as toggle-box
     size 50 by .81 no-undo.

define variable Toggle_Buildtemplate as logical initial no 
     label "Build from this template" 
     view-as toggle-box
     size 34 by 1 no-undo.

define variable Toggle_Exists as logical initial no 
     label "Build if target file e&xists" 
     view-as toggle-box
     size 33 by .81 no-undo.


/* ************************  Frame Definitions  *********************** */

define frame Dialog-Frame
     fillin_template at row 1.71 col 18 colon-aligned
     Toggle_Buildtemplate at row 2.91 col 20 widget-id 2
     Toggle_Exists at row 3.86 col 20 widget-id 6
     TOGGLE-1 at row 4.81 col 20 widget-id 4
     Button_Save at row 6.24 col 40 help
          "ContextDone"
     Btn_Cancel at row 6.24 col 56 help
          "ContextDone"
     RECT-7 at row 1.24 col 2
     space(1.99) skip(1.90)
    with view-as dialog-box keep-tab-order 
         side-labels no-underline three-d  scrollable 
         title "Update Template"
         default-button Button_Save cancel-button Btn_Cancel
         context-help.


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: DIALOG-BOX
   Allow: Basic,Browse,DB-Fields,Query
   Other Settings: COMPILE
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS



/* ***********  Runtime Attributes and AppBuilder Settings  *********** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR DIALOG-BOX Dialog-Frame
   FRAME-NAME                                                           */
assign 
       frame Dialog-Frame:SCROLLABLE       = false.

/* SETTINGS FOR FILL-IN fillin_template IN FRAME Dialog-Frame
   3                                                                    */
/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME


/* Setting information for Queries and Browse Widgets fields            */

&ANALYZE-SUSPEND _QUERY-BLOCK DIALOG-BOX Dialog-Frame
/* Query rebuild information for DIALOG-BOX Dialog-Frame
     _Options          = "no-lock indexED-REPOSITION KEEP-EMPTY"
     _Query            is NOT OPENED
*/  /* DIALOG-BOX Dialog-Frame */
&ANALYZE-RESUME

 



/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME Dialog-Frame
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL Dialog-Frame Dialog-Frame
on go of frame Dialog-Frame /* Update Template */
do:
 assign p_Template:Build         = Toggle_Buildtemplate:checked
        p_Template:BuildIfSame   = TOGGLE-1:checked          
        p_Template:BuildIfExists = Toggle_Exists:checked          
        p_Template:TemplateName  = fillin_Template:screen-value.
 
 if not VerifyData() then return no-apply.
end.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL Dialog-Frame Dialog-Frame
on window-close of frame Dialog-Frame /* Update Template */
do:
  apply "END-ERROR":U to self.
end.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK Dialog-Frame 


/* ***************************  Main Block  *************************** */

/* Parent the dialog-box to the ACTIVE-WINDOW, if there is no parent.   */
if valid-handle(active-window) and frame {&FRAME-NAME}:PARENT eq ?
then frame {&FRAME-NAME}:PARENT = active-window.

if p_Template:TemplateName eq "" then assign frame {&FRAME-NAME}:TITLE = "Create New Template".

/* Now enable the interface and wait for the exit condition.            */
/* (NOTE: handle ERROR and END-KEY so cleanup code will always fire.    */
MAIN-BLOCK:
do on error   undo MAIN-BLOCK, leave MAIN-BLOCK
   on end-key undo MAIN-BLOCK, leave MAIN-BLOCK:
  
  Startup().
  
  run enable_UI.
  
  wait-for go of frame {&FRAME-NAME}.
end.
run disable_UI.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI Dialog-Frame  _DEFAULT-DISABLE
procedure disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Hide all frames. */
  hide frame Dialog-Frame.
end procedure.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI Dialog-Frame  _DEFAULT-ENABLE
procedure enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other 
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/
  display fillin_template Toggle_Buildtemplate Toggle_Exists TOGGLE-1 
      with frame Dialog-Frame.
  enable RECT-7 fillin_template Toggle_Buildtemplate Toggle_Exists TOGGLE-1 
         Button_Save Btn_Cancel 
      with frame Dialog-Frame.
  {&OPEN-BROWSERS-IN-QUERY-Dialog-Frame}
end procedure.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

/* ************************  Function Implementations ***************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION StartUp Dialog-Frame 
function StartUp returns logical ():
      
 assign Toggle_Buildtemplate = p_Template:Build
        TOGGLE-1             = p_Template:BuildIfSame
        Toggle_Exists        = p_Template:BuildIfExists          
        fillin_template      = p_Template:TemplateName.          
        
end function.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION VerifyData Dialog-Frame 
function VerifyData returns logical
  ( ) :
  do on error undo, leave:

  end.
  
  return yes.
  
end function.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

