/*
Copyright (c) 2011, Julian Lyndon-Smith (julian+maia@dotr.com)
http://www.dotr.com
All rights reserved.

Permission is hereby granted, free of charge, to any person
obtaining a copy of this software and associated documentation
files (the "Software"), to deal in the Software without
restriction except as noted below, including without limitation
the rights to use,copy, modify, merge, publish, distribute,
and/or sublicense, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

 The Software and/or source code cannot be copied in whole and
 sold without meaningful modification for a profit.

 The above copyright notice and this permission notice shall be
 included in all copies or substantial portions of the Software.

 Redistributions of source code must retain the above copyright
 notice, this list of conditions and the following disclaimer.

 Redistributions in binary form must reproduce the above copyright
 notice, this list of conditions and the following disclaimer in
 the documentation and/or other materials provided with
 the distribution.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.
*/

using Progress.Lang.*.
using dotr.Maia.*.

routine-level on error undo, throw.

class dotr.Maia.UI.winform.dotrForm inherits DevExpress.XtraEditors.XtraForm: 
  
  constructor public dotrForm():
    this-object:Load:Subscribe(this-object:dotrForm_Load).
  end constructor.
  
  method private void NewSkin(p_Skin as char):
    this-object:LookAndFeel:SkinName = p_Skin.
  end method.  

  method private void dotrForm_Load( input sender as System.Object, input e as System.EventArgs ):
    this-object:LookAndFeel:SkinName = "".
    this-object:LookAndFeel:UseDefaultLookAndFeel = false.
    
    dotr.Maia.UI.Library.Skin:SkinChanged:Subscribe(NewSkin).
    this-object:LookAndFeel:SkinName = dotr.Maia.UI.Library.Skin:Instance:CurrentSkin.
  end method.

	destructor public dotrForm ( ):
    dotr.Maia.UI.Library.Skin:SkinChanged:UnSubscribe(NewSkin).
	end destructor.
  
end class.