
/*
Copyright (C) 2011 by Julian Lyndon-Smith (julian+mit@dotr.com)

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS for A PARTICULAR PURPOSE and NONINFRINGEMENT. IN no EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE for ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR otherwise, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
*/

/* $Id$ */

using Progress.Lang.*.
using Progress.Windows.UserControl.

routine-level on error undo, throw.

class sports.UI.winform.Lookup.Customerlookup inherits UserControl: 
  def private var colCustNum as DevExpress.XtraGrid.Columns.GridColumn no-undo.
  def private var colName as DevExpress.XtraGrid.Columns.GridColumn no-undo. 
  
  def private var bindingSource1 as Progress.Data.BindingSource no-undo.
  def private var components as System.ComponentModel.IContainer no-undo.
  def private var gridLookUpEdit1View as DevExpress.XtraGrid.Views.Grid.GridView no-undo.
  def private var gridLookUpEdit1 as DevExpress.XtraEditors.GridLookUpEdit no-undo.
  
  def var Model1 as sports.Model.Customer no-undo.
  def public event DataChanged signature void (p_Lookup as sports.UI.winform.Lookup.CustomerLookup,p_Data as char).

  def public property DisplayValue as char no-undo get . private set.
	
	def public property KeyValue     as char no-undo get . 
    set(p_KeyValue as char):
      assign gridLookUpEdit1:EditValue = p_KeyValue
             KeyValue                  = p_KeyValue.
	  end set.
	  	
	constructor public Customerlookup (  ):
    super().
    InitializeComponent().
    catch e as Progress.Lang.Error:
      undo, throw e.
    end catch.

	end constructor.

  /** Publish a new Data value
   *
   * @param Standard Event Args
   * @return void
   */
	@VisualDesigner.
	method private void gridLookUpEdit1_EditValueChanged( input sender as System.Object, input e as System.EventArgs ):
		assign KeyValue     = gridLookUpEdit1:EditValue
		       DisplayValue = gridLookUpEdit1:Text.

		this-object:DataChanged:Publish(this-object,KeyValue).
		return.

	end method.

	method private void InitializeComponent(  ):
		
    /* NOTE: The following method is automatically generated.
    
    We strongly suggest that the contents of this method only be modified using the
    Visual Designer to avoid any incompatible modifications.
    
    Modifying the contents of this method using a code editor will invalidate any support for this file. */
    this-object:components = new System.ComponentModel.Container().
    @VisualDesigner.FormMember (NeedsInitialize="true").
    def var tableDesc1 as Progress.Data.TableDesc no-undo.
    tableDesc1 = new Progress.Data.TableDesc("File").
    this-object:gridLookUpEdit1 = new DevExpress.XtraEditors.GridLookUpEdit().
    this-object:bindingSource1 = new Progress.Data.BindingSource(this-object:components).
    this-object:gridLookUpEdit1View = new DevExpress.XtraGrid.Views.Grid.GridView().
    this-object:colCustNum = new DevExpress.XtraGrid.Columns.GridColumn().
    this-object:colName = new DevExpress.XtraGrid.Columns.GridColumn(). 
    cast(this-object:gridLookUpEdit1:Properties, System.ComponentModel.ISupportInitialize):BeginInit().
    cast(this-object:bindingSource1, System.ComponentModel.ISupportInitialize):BeginInit().
    cast(this-object:gridLookUpEdit1View, System.ComponentModel.ISupportInitialize):BeginInit().
    this-object:SuspendLayout().
    /*  */
    /* gridLookUpEdit1 */
    /*  */
    this-object:gridLookUpEdit1:Dock = System.Windows.Forms.DockStyle:Fill.
    this-object:gridLookUpEdit1:Location = new System.Drawing.Point(0, 0).
    this-object:gridLookUpEdit1:Name = "gridLookUpEdit1".
    this-object:gridLookUpEdit1:EditValue = "".
    @VisualDesigner.FormMember (NeedsInitialize="false", InitializeArray="true").
    def var arrayvar0 as DevExpress.XtraEditors.Controls.EditorButton extent 1 no-undo.
    arrayvar0[1] = new DevExpress.XtraEditors.Controls.EditorButton(DevExpress.XtraEditors.Controls.ButtonPredefines:Combo).
    this-object:gridLookUpEdit1:Properties:Buttons:AddRange(arrayvar0).
    this-object:gridLookUpEdit1:Properties:DataSource = this-object:bindingSource1.
    this-object:gridLookUpEdit1:Properties:ValueMember = "Cust-Num".
    this-object:gridLookUpEdit1:Properties:View = this-object:gridLookUpEdit1View.
    this-object:gridLookUpEdit1:Size = new System.Drawing.Size(165, 20).
    this-object:gridLookUpEdit1:TabIndex = 4.
    this-object:gridLookUpEdit1:EditValueChanged:Subscribe(this-object:gridLookUpEdit1_EditValueChanged).
    /*  */
    /* bindingSource1 */
    /*  */
    this-object:bindingSource1:MaxDataGuess = 0.
    this-object:bindingSource1:NoLOBs = false.
    this-object:bindingSource1:Position = 0.
    @VisualDesigner.FormMember (NeedsInitialize="false", InitializeArray="true").
    def var arrayvar1 as "Progress.Data.TableDesc[]" no-undo.
    arrayvar1 = new "Progress.Data.TableDesc[]"(0).
    tableDesc1:ChildTables = arrayvar1.
    @VisualDesigner.FormMember (NeedsInitialize="false", InitializeArray="true").
    def var arrayvar2 AS Progress.Data.ColumnPropDesc EXTENT 3 NO-undo.
    arrayvar2[1] = new Progress.Data.ColumnPropDesc("Cust-Num", "Cust-Num", Progress.Data.DataType:CHARACTER).
    arrayvar2[2] = new Progress.Data.ColumnPropDesc("CustNum", "Cust-Num", Progress.Data.DataType:CHARACTER).
    arrayvar2[3] = new Progress.Data.ColumnPropDesc("Name", "Name", Progress.Data.DataType:CHARACTER).
    tableDesc1:Columns = arrayvar2.
    this-object:gridLookUpEdit1:Properties:DisplayMember = "Name". 
    this-object:bindingSource1:TableSchema = tableDesc1.
    /*  */
    /* gridLookUpEdit1View */
    /*  */
    this-object:gridLookUpEdit1View:Appearance:EvenRow:Options:UseBackColor = true.
    this-object:gridLookUpEdit1View:Appearance:OddRow:BackColor = System.Drawing.Color:LemonChiffon.
    this-object:gridLookUpEdit1View:Appearance:OddRow:Options:UseBackColor = true.
    @VisualDesigner.FormMember (NeedsInitialize="false", InitializeArray="true").
    def var LookupArray as DevExpress.XtraGrid.Columns.GridColumn extent 2 no-undo.
    LookupArray[1] = this-object:colCustNum.
    LookupArray[2] = this-object:colName.
    this-object:gridLookUpEdit1View:Columns:AddRange(LookupArray). 
    this-object:gridLookUpEdit1View:FocusRectStyle = DevExpress.XtraGrid.Views.Grid.DrawFocusRectStyle:RowFocus.
    this-object:gridLookUpEdit1View:Name = "gridLookUpEdit1View".
    this-object:gridLookUpEdit1View:OptionsBehavior:AllowAddRows = DevExpress.Utils.DefaultBoolean:false.
    this-object:gridLookUpEdit1View:OptionsBehavior:AllowDeleteRows = DevExpress.Utils.DefaultBoolean:false.
    this-object:gridLookUpEdit1View:OptionsBehavior:Editable = false.
    this-object:gridLookUpEdit1View:OptionsBehavior:ReadOnly = true.
    this-object:gridLookUpEdit1View:OptionsSelection:EnableAppearanceFocusedCell = false.
    this-object:gridLookUpEdit1View:OptionsView:EnableAppearanceEvenRow = true.
    this-object:gridLookUpEdit1View:OptionsView:EnableAppearanceOddRow = true.
    this-object:gridLookUpEdit1View:OptionsView:ShowGroupPanel = false.

    /*  */
    /* colCustNum */
    /*  */
    THIS-OBJECT:colCustNum:Caption = "CustNum".
    THIS-OBJECT:colCustNum:FieldName = "Cust-Num".
    THIS-OBJECT:colCustNum:Name = "colCustNum".
    THIS-OBJECT:colCustNum:Visible = TRUE.
    THIS-OBJECT:colCustNum:VisibleIndex = 0.
    /*  */
    /* colName */
    /*  */
    THIS-OBJECT:colName:Caption = "Name".
    THIS-OBJECT:colName:FieldName = "Name".
    THIS-OBJECT:colName:Name = "colName".
    THIS-OBJECT:colName:Visible = TRUE.
    THIS-OBJECT:colName:VisibleIndex = 1. 

    /*  */
    /* Lookup */
    /*  */
    this-object:AutoScaleDimensions = new System.Drawing.SizeF(6, 13).
    this-object:CausesValidation = false.
    this-object:Controls:Add(this-object:gridLookUpEdit1).
    this-object:Name = "Lookup".
    this-object:Size = new System.Drawing.Size(165, 20).
    this-object:Resize:Subscribe(this-object:Lookup_Resize).
    cast(this-object:gridLookUpEdit1:Properties, System.ComponentModel.ISupportInitialize):endInit().
    cast(this-object:bindingSource1, System.ComponentModel.ISupportInitialize):endInit().
    cast(this-object:gridLookUpEdit1View, System.ComponentModel.ISupportInitialize):endInit().
    this-object:ResumeLayout(false).
    catch e as Progress.Lang.Error:
      undo, throw e.
    end catch.
	end method.

	destructor public CustomerLookup ( ):

		if valid-object(components) then do:
			cast(components, System.IDisposable):Dispose().
		end.

	end destructor.

  /** Loads the query data
   *
   * @param NONE
   * @return void
   */
  method public void init():
    Init("").
  end method.

  /** Loads the query data
   *
   * @param NONE
   * @return void
   */
  method public void init(p_Where as char):
    Model1 = sports.Helper.Customer:FindWhere(bindingSource1,p_Where).
  end method.

  /** Prevents the combo from being resized vertically
   *
   * @param NONE
   * @return void
   */
	@VisualDesigner.
	method private void Lookup_Resize( input sender as System.Object, input e as System.EventArgs ):
		this-object:Height = 20.
		return.

	end method.


end class.
@BuildInfo(Source="./sports/_Maia-Config/Customer/_Config.xml").
@BuildInfo(Date="30/08/2011 08:37:15.151+01:00").