
/*
Copyright (C) 2011 by Julian Lyndon-Smith (julian+mit@dotr.com)

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS for A PARTICULAR PURPOSE and NONINFRINGEMENT. IN no EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE for ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR otherwise, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
*/

/* $Id$ */

using Progress.Lang.*.
using Progress.Windows.Form.

routine-level on error undo, throw.

class sports.UI.winform.Ribbon.Base.SalesrepBaseRibbon inherits dotr.Maia.UI.winform.dotrRibbonForm: 
  def protected var colRepName  AS DevExpress.XtraGrid.Columns.GridColumn NO-UNDO.
  def protected var colRepName1 AS DevExpress.XtraGrid.Columns.GridColumn NO-UNDO.
  def protected var colSalesRep  AS DevExpress.XtraGrid.Columns.GridColumn NO-UNDO.
  def protected var colSalesRep1 AS DevExpress.XtraGrid.Columns.GridColumn NO-UNDO.
  def var Model1 as sports.Model.Salesrep     no-undo.
  def var Stomp1 as dotr.Maia.Stomp.Helper.Client no-undo.

  define protected variable barButtonItem1 as DevExpress.XtraBars.BarButtonItem no-undo.
  define protected variable applicationMenu1 as DevExpress.XtraBars.Ribbon.ApplicationMenu no-undo.
  define protected variable bbiAbout as DevExpress.XtraBars.BarButtonItem no-undo.
  define protected variable bbiUp as DevExpress.XtraBars.BarButtonItem no-undo.
  define protected variable bbiRefresh as DevExpress.XtraBars.BarButtonItem no-undo.
  define protected variable bbiPrintPreview as DevExpress.XtraBars.BarButtonItem no-undo.
  define protected variable bbiEdit as DevExpress.XtraBars.BarButtonItem no-undo.
  define protected variable bbiDown as DevExpress.XtraBars.BarButtonItem no-undo.
  define protected variable bbiDisplayStyle as DevExpress.XtraBars.BarSubItem no-undo.
  define protected variable bbiDelete as DevExpress.XtraBars.BarButtonItem no-undo.
  define protected variable bbiAdd as DevExpress.XtraBars.BarButtonItem no-undo.
  define protected variable biExportToText as DevExpress.XtraBars.BarButtonItem no-undo.
  define protected variable biExportToExcel as DevExpress.XtraBars.BarButtonItem no-undo.
  define protected variable biExportPDF as DevExpress.XtraBars.BarButtonItem no-undo.
  define protected variable bindingSource1 as Progress.Data.BindingSource no-undo.
  define protected variable CardItem as DevExpress.XtraBars.BarStaticItem no-undo.
  define protected variable cardView1 as DevExpress.XtraGrid.Views.Card.CardView no-undo.
	
	define private variable components as System.ComponentModel.IContainer no-undo.
  
  define protected variable GridItem as DevExpress.XtraBars.BarStaticItem no-undo.
  define protected variable gridView1 as DevExpress.XtraGrid.Views.Grid.GridView no-undo.
  define protected variable gridControl1 as DevExpress.XtraGrid.GridControl no-undo.
    define private variable ribbonGalleryBarItem1 as DevExpress.XtraBars.RibbonGalleryBarItem no-undo.
  define protected variable ribbonPageGroup3 as DevExpress.XtraBars.Ribbon.RibbonPageGroup no-undo.
  define protected variable ribbonPageGroup2 as DevExpress.XtraBars.Ribbon.RibbonPageGroup no-undo.
  define protected variable ribbonPageGroup1 as DevExpress.XtraBars.Ribbon.RibbonPageGroup no-undo.
  define protected variable ribbonPage1 as DevExpress.XtraBars.Ribbon.RibbonPage no-undo.
  define protected variable ribbonControl1 as DevExpress.XtraBars.Ribbon.RibbonControl no-undo.
    define private variable ribbonPageGroup4 as DevExpress.XtraBars.Ribbon.RibbonPageGroup no-undo.
  define protected variable siExport as DevExpress.XtraBars.BarSubItem no-undo.

		
	constructor public SalesrepBaseRibbon (  ):
		super().
    InitializeComponent().
    
    Stomp1 = new dotr.Maia.Stomp.Helper.Client("localhost").
    
    Stomp1:SubscribeToTopic("sports.info.db.update.Salesrep").
    Stomp1:NewMessage:Subscribe(NewStompMessage).
    
    catch e as Progress.Lang.Error:
      undo, throw e.
    end catch.

	end constructor.

  method public void NewStompMessage(p_Message as dotr.Maia.Stomp.Interface.IStompMessage):
    if p_Message:Body begins "action:update" then bindingSource1:Refresh().
    else Model1:FindWhere(bindingSource1,"").
  end method.

	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	method private void Salesrep_Load( input sender as System.Object, input e as System.EventArgs ):
    Model1 = new sports.Model.Salesrep().
    
    DevExpress.UserSkins.BonusSkins:Register().

    DevExpress.UserSkins.OfficeSkins:Register().

    DevExpress.XtraBars.Helpers.SkinHelper:InitSkinGallery(RibbonGalleryBarItem1, true, true).
    
    Model1:FindWhere(bindingSource1,"").
   
		return.

	end method.


	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	method private void barButtonItem8_ItemClick( input sender as System.Object, input e as DevExpress.XtraBars.ItemClickEventArgs ):
		ItemClicked("about").
		return.

	end method.

	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	method private void bbiAdd_ItemClick( input sender as System.Object, input e as DevExpress.XtraBars.ItemClickEventArgs ):
		ItemClicked("new").
		return.

	end method.

	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	method private void bbiDelete_ItemClick( input sender as System.Object, input e as DevExpress.XtraBars.ItemClickEventArgs ):
		ItemClicked("remove").
		return.

	end method.

	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	method private void bbiDown_ItemClick( input sender as System.Object, input e as DevExpress.XtraBars.ItemClickEventArgs ):
		ItemClicked("down").
		return.

	end method.

	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	method private void bbiEdit_ItemClick( input sender as System.Object, input e as DevExpress.XtraBars.ItemClickEventArgs ):
		ItemClicked("Update").
		return.

	end method.

	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	method private void bbiPrintPreview_ItemClick( input sender as System.Object, input e as DevExpress.XtraBars.ItemClickEventArgs ):
	 ItemClicked("PrintPreview").	
		return.

	end method.

	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	method private void bbiRefresh_ItemClick( input sender as System.Object, input e as DevExpress.XtraBars.ItemClickEventArgs ):
	  ItemClicked("refresh").	
		return.

	end method.

	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	method private void bbiUp_ItemClick( input sender as System.Object, input e as DevExpress.XtraBars.ItemClickEventArgs ):
	 ItemClicked("up").	
		return.

	end method.



	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	method private void biExportPDF_ItemClick( input sender as System.Object, input e as DevExpress.XtraBars.ItemClickEventArgs ):
		ItemClicked("exportPDF").
		return.

	end method.

	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	method private void biExportToExcel_ItemClick( input sender as System.Object, input e as DevExpress.XtraBars.ItemClickEventArgs ):
		ItemClicked("exportExcel").
		return.

	end method.

	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	method private void biExportToText_ItemClick( input sender as System.Object, input e as DevExpress.XtraBars.ItemClickEventArgs ):
	  ItemClicked("exportText").	
		return.

	end method.

	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	method private void CardItem_ItemClick( input sender as System.Object, input e as DevExpress.XtraBars.ItemClickEventArgs ):
		ItemClicked("ShowCards").
		return.

	end method.

	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	method private void gridControl1_DoubleClick( input sender as System.Object, input e as System.EventArgs ):
		UpdatePressed().
		return.

	end method.

	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	method private void GridItem_ItemClick( input sender as System.Object, input e as DevExpress.XtraBars.ItemClickEventArgs ):
		ItemClicked("ShowGrid").
		return.

	end method.

	method private void InitializeComponent(  ):
    /* NOTE: The following method is automatically generated.
    
    We strongly suggest that the contents of this method only be modified using the
    Visual Designer to avoid any incompatible modifications.
    
    Modifying the contents of this method using a code editor will invalidate any support for this file. */
        this-object:components = new System.ComponentModel.Container().
        @VisualDesigner.FormMember (NeedsInitialize="true").
        define variable resources as Progress.Util.ResourceManager no-undo.
        resources = new Progress.Util.ResourceManager("sports.UI.winform.Ribbon.Base.SalesrepBaseRibbon").
        @VisualDesigner.FormMember (NeedsInitialize="true").
        define variable gridLevelNode1 as DevExpress.XtraGrid.GridLevelNode no-undo.
        gridLevelNode1 = new DevExpress.XtraGrid.GridLevelNode().
        this-object:ribbonControl1 = new DevExpress.XtraBars.Ribbon.RibbonControl().
        this-object:applicationMenu1 = new DevExpress.XtraBars.Ribbon.ApplicationMenu(this-object:components).
        this-object:bbiPrintPreview = new DevExpress.XtraBars.BarButtonItem().
        this-object:siExport = new DevExpress.XtraBars.BarSubItem().
        this-object:biExportPDF = new DevExpress.XtraBars.BarButtonItem().
        this-object:biExportToExcel = new DevExpress.XtraBars.BarButtonItem().
        this-object:bbiDisplayStyle = new DevExpress.XtraBars.BarSubItem().
        this-object:GridItem = new DevExpress.XtraBars.BarStaticItem().
        this-object:CardItem = new DevExpress.XtraBars.BarStaticItem().
        this-object:bbiAdd = new DevExpress.XtraBars.BarButtonItem().
        this-object:bbiEdit = new DevExpress.XtraBars.BarButtonItem().
        this-object:bbiDelete = new DevExpress.XtraBars.BarButtonItem().
        this-object:bbiRefresh = new DevExpress.XtraBars.BarButtonItem().
        this-object:bbiUp = new DevExpress.XtraBars.BarButtonItem().
        this-object:bbiDown = new DevExpress.XtraBars.BarButtonItem().
        this-object:bbiAbout = new DevExpress.XtraBars.BarButtonItem().
        this-object:barButtonItem1 = new DevExpress.XtraBars.BarButtonItem().
        this-object:biExportToText = new DevExpress.XtraBars.BarButtonItem().
        this-object:ribbonGalleryBarItem1 = new DevExpress.XtraBars.RibbonGalleryBarItem().
        this-object:ribbonPage1 = new DevExpress.XtraBars.Ribbon.RibbonPage().
        this-object:ribbonPageGroup2 = new DevExpress.XtraBars.Ribbon.RibbonPageGroup().
        this-object:ribbonPageGroup1 = new DevExpress.XtraBars.Ribbon.RibbonPageGroup().
        this-object:ribbonPageGroup3 = new DevExpress.XtraBars.Ribbon.RibbonPageGroup().
        this-object:ribbonPageGroup4 = new DevExpress.XtraBars.Ribbon.RibbonPageGroup().
        this-object:gridControl1 = new DevExpress.XtraGrid.GridControl().
        this-object:bindingSource1 = new Progress.Data.BindingSource(this-object:components).
        this-object:cardView1 = new DevExpress.XtraGrid.Views.Card.CardView().
        this-object:gridView1 = new DevExpress.XtraGrid.Views.Grid.GridView().
        cast(this-object:ribbonControl1, System.ComponentModel.ISupportInitialize):BeginInit().
        cast(this-object:applicationMenu1, System.ComponentModel.ISupportInitialize):BeginInit().
        cast(this-object:gridControl1, System.ComponentModel.ISupportInitialize):BeginInit().
        cast(this-object:bindingSource1, System.ComponentModel.ISupportInitialize):BeginInit().
        cast(this-object:cardView1, System.ComponentModel.ISupportInitialize):BeginInit().
        cast(this-object:gridView1, System.ComponentModel.ISupportInitialize):BeginInit().
        this-object:SuspendLayout().
        /*  */
        /* ribbonControl1 */
        /*  */
        this-object:ribbonControl1:ApplicationButtonDropDownControl = this-object:applicationMenu1.
        this-object:ribbonControl1:ApplicationButtonText = ?.
        /*  */
        /*  */
        /*  */
        this-object:ribbonControl1:ExpandCollapseItem:Id = 0.
        this-object:ribbonControl1:ExpandCollapseItem:Name = "".
        @VisualDesigner.FormMember (NeedsInitialize="false", InitializeArray="true").
        define variable arrayvar0 as DevExpress.XtraBars.BarItem extent 18 no-undo.
        arrayvar0[1] = this-object:ribbonControl1:ExpandCollapseItem.
        arrayvar0[2] = this-object:bbiAdd.
        arrayvar0[3] = this-object:bbiEdit.
        arrayvar0[4] = this-object:bbiDelete.
        arrayvar0[5] = this-object:bbiRefresh.
        arrayvar0[6] = this-object:bbiUp.
        arrayvar0[7] = this-object:bbiDown.
        arrayvar0[8] = this-object:bbiPrintPreview.
        arrayvar0[9] = this-object:bbiDisplayStyle.
        arrayvar0[10] = this-object:GridItem.
        arrayvar0[11] = this-object:CardItem.
        arrayvar0[12] = this-object:bbiAbout.
        arrayvar0[13] = this-object:barButtonItem1.
        arrayvar0[14] = this-object:siExport.
        arrayvar0[15] = this-object:biExportPDF.
        arrayvar0[16] = this-object:biExportToExcel.
        arrayvar0[17] = this-object:biExportToText.
        arrayvar0[18] = this-object:ribbonGalleryBarItem1.
        this-object:ribbonControl1:Items:AddRange(arrayvar0).
        this-object:ribbonControl1:Location = new System.Drawing.Point(0, 0).
        this-object:ribbonControl1:MaxItemId = 43.
        this-object:ribbonControl1:Name = "ribbonControl1".
        this-object:ribbonControl1:PageHeaderItemLinks:Add(this-object:bbiAbout).
        @VisualDesigner.FormMember (NeedsInitialize="false", InitializeArray="true").
        define variable arrayvar1 as DevExpress.XtraBars.Ribbon.RibbonPage extent 1 no-undo.
        arrayvar1[1] = this-object:ribbonPage1.
        this-object:ribbonControl1:Pages:AddRange(arrayvar1).
        this-object:ribbonControl1:RibbonStyle = DevExpress.XtraBars.Ribbon.RibbonControlStyle:Office2010.
        this-object:ribbonControl1:SelectedPage = this-object:ribbonPage1.
        this-object:ribbonControl1:Size = new System.Drawing.Size(1124, 145).
        this-object:ribbonControl1:Toolbar:ItemLinks:Add(this-object:bbiRefresh).
        /*  */
        /* applicationMenu1 */
        /*  */
        this-object:applicationMenu1:ItemLinks:Add(this-object:bbiPrintPreview).
        this-object:applicationMenu1:ItemLinks:Add(this-object:siExport).
        this-object:applicationMenu1:ItemLinks:Add(this-object:bbiDisplayStyle).
        this-object:applicationMenu1:Name = "applicationMenu1".
        this-object:applicationMenu1:Ribbon = this-object:ribbonControl1.
        /*  */
        /* bbiPrintPreview */
        /*  */
        this-object:bbiPrintPreview:Caption = "Print Preview".
        this-object:bbiPrintPreview:Id = 17.
        this-object:bbiPrintPreview:LargeGlyph = cast(resources:GetObject("bbiPrintPreview.LargeGlyph"), System.Drawing.Image).
        this-object:bbiPrintPreview:Name = "bbiPrintPreview".
        this-object:bbiPrintPreview:ItemClick:Subscribe(this-object:bbiPrintPreview_ItemClick).
        /*  */
        /* siExport */
        /*  */
        this-object:siExport:Caption = "Export".
        this-object:siExport:Id = 38.
        this-object:siExport:LargeGlyph = cast(resources:GetObject("siExport.LargeGlyph"), System.Drawing.Image).
        @VisualDesigner.FormMember (NeedsInitialize="false", InitializeArray="true").
        define variable arrayvar2 as DevExpress.XtraBars.LinkPersistInfo extent 2 no-undo.
        arrayvar2[1] = new DevExpress.XtraBars.LinkPersistInfo(this-object:biExportPDF).
        arrayvar2[2] = new DevExpress.XtraBars.LinkPersistInfo(this-object:biExportToExcel).
        this-object:siExport:LinksPersistInfo:AddRange(arrayvar2).
        this-object:siExport:MenuDrawMode = DevExpress.XtraBars.MenuDrawMode:SmallImagesText.
        this-object:siExport:Name = "siExport".
        /*  */
        /* biExportPDF */
        /*  */
        this-object:biExportPDF:Caption = "Export to PDF".
        this-object:biExportPDF:Glyph = cast(resources:GetObject("biExportPDF.Glyph"), System.Drawing.Image).
        this-object:biExportPDF:Id = 39.
        this-object:biExportPDF:Name = "biExportPDF".
        this-object:biExportPDF:ItemClick:Subscribe(this-object:biExportPDF_ItemClick).
        /*  */
        /* biExportToExcel */
        /*  */
        this-object:biExportToExcel:Caption = "Export to Excel".
        this-object:biExportToExcel:Glyph = cast(resources:GetObject("biExportToExcel.Glyph"), System.Drawing.Image).
        this-object:biExportToExcel:Id = 40.
        this-object:biExportToExcel:Name = "biExportToExcel".
        this-object:biExportToExcel:ItemClick:Subscribe(this-object:biExportToExcel_ItemClick).
        /*  */
        /* bbiDisplayStyle */
        /*  */
        this-object:bbiDisplayStyle:Caption = "Display Style".
        this-object:bbiDisplayStyle:Id = 23.
        this-object:bbiDisplayStyle:LargeGlyph = cast(resources:GetObject("bbiDisplayStyle.LargeGlyph"), System.Drawing.Image).
        @VisualDesigner.FormMember (NeedsInitialize="false", InitializeArray="true").
        define variable arrayvar3 as DevExpress.XtraBars.LinkPersistInfo extent 2 no-undo.
        arrayvar3[1] = new DevExpress.XtraBars.LinkPersistInfo(DevExpress.XtraBars.BarLinkUserDefines:PaintStyle, this-object:GridItem, DevExpress.XtraBars.BarItemPaintStyle:CaptionGlyph).
        arrayvar3[2] = new DevExpress.XtraBars.LinkPersistInfo(DevExpress.XtraBars.BarLinkUserDefines:PaintStyle, this-object:CardItem, DevExpress.XtraBars.BarItemPaintStyle:CaptionGlyph).
        this-object:bbiDisplayStyle:LinksPersistInfo:AddRange(arrayvar3).
        this-object:bbiDisplayStyle:MenuDrawMode = DevExpress.XtraBars.MenuDrawMode:SmallImagesText.
        this-object:bbiDisplayStyle:Name = "bbiDisplayStyle".
        /*  */
        /* GridItem */
        /*  */
        this-object:GridItem:Caption = "Grid".
        this-object:GridItem:Glyph = cast(resources:GetObject("GridItem.Glyph"), System.Drawing.Image).
        this-object:GridItem:Id = 24.
        this-object:GridItem:Name = "GridItem".
        this-object:GridItem:TextAlignment = System.Drawing.StringAlignment:Near.
        this-object:GridItem:ItemClick:Subscribe(this-object:GridItem_ItemClick).
        /*  */
        /* CardItem */
        /*  */
        this-object:CardItem:Caption = "Cards".
        this-object:CardItem:Glyph = cast(resources:GetObject("CardItem.Glyph"), System.Drawing.Image).
        this-object:CardItem:Id = 25.
        this-object:CardItem:Name = "CardItem".
        this-object:CardItem:TextAlignment = System.Drawing.StringAlignment:Near.
        this-object:CardItem:ItemClick:Subscribe(this-object:CardItem_ItemClick).
        /*  */
        /* bbiAdd */
        /*  */
        this-object:bbiAdd:Caption = "Add".
        this-object:bbiAdd:Id = 2.
        this-object:bbiAdd:LargeGlyph = cast(resources:GetObject("bbiAdd.LargeGlyph"), System.Drawing.Image).
        this-object:bbiAdd:Name = "bbiAdd".
        this-object:bbiAdd:ItemClick:Subscribe(this-object:bbiAdd_ItemClick).
        /*  */
        /* bbiEdit */
        /*  */
        this-object:bbiEdit:Caption = "Edit".
        this-object:bbiEdit:Id = 3.
        this-object:bbiEdit:LargeGlyph = cast(resources:GetObject("bbiEdit.LargeGlyph"), System.Drawing.Image).
        this-object:bbiEdit:Name = "bbiEdit".
        this-object:bbiEdit:ItemClick:Subscribe(this-object:bbiEdit_ItemClick).
        /*  */
        /* bbiDelete */
        /*  */
        this-object:bbiDelete:Caption = "Delete".
        this-object:bbiDelete:Id = 4.
        this-object:bbiDelete:LargeGlyph = cast(resources:GetObject("bbiDelete.LargeGlyph"), System.Drawing.Image).
        this-object:bbiDelete:Name = "bbiDelete".
        this-object:bbiDelete:ItemClick:Subscribe(this-object:bbiDelete_ItemClick).
        /*  */
        /* bbiRefresh */
        /*  */
        this-object:bbiRefresh:Caption = "Refresh".
        this-object:bbiRefresh:Glyph = cast(resources:GetObject("bbiRefresh.Glyph"), System.Drawing.Image).
        this-object:bbiRefresh:Id = 6.
        this-object:bbiRefresh:LargeGlyph = cast(resources:GetObject("bbiRefresh.LargeGlyph"), System.Drawing.Image).
        this-object:bbiRefresh:Name = "bbiRefresh".
        this-object:bbiRefresh:ItemClick:Subscribe(this-object:bbiRefresh_ItemClick).
        /*  */
        /* bbiUp */
        /*  */
        this-object:bbiUp:Caption = "Up".
        this-object:bbiUp:Glyph = cast(resources:GetObject("bbiUp.Glyph"), System.Drawing.Image).
        this-object:bbiUp:Id = 8.
        this-object:bbiUp:Name = "bbiUp".
        this-object:bbiUp:ItemClick:Subscribe(this-object:bbiUp_ItemClick).
        /*  */
        /* bbiDown */
        /*  */
        this-object:bbiDown:Caption = "Down".
        this-object:bbiDown:Glyph = cast(resources:GetObject("bbiDown.Glyph"), System.Drawing.Image).
        this-object:bbiDown:Id = 9.
        this-object:bbiDown:Name = "bbiDown".
        this-object:bbiDown:ItemClick:Subscribe(this-object:bbiDown_ItemClick).
        /*  */
        /* bbiAbout */
        /*  */
        this-object:bbiAbout:Caption = "About".
        this-object:bbiAbout:Glyph = cast(resources:GetObject("bbiAbout.Glyph"), System.Drawing.Image).
        this-object:bbiAbout:Id = 26.
        this-object:bbiAbout:LargeGlyph = cast(resources:GetObject("bbiAbout.LargeGlyph"), System.Drawing.Image).
        this-object:bbiAbout:Name = "bbiAbout".
        this-object:bbiAbout:ItemClick:Subscribe(this-object:barButtonItem8_ItemClick).
        /*  */
        /* barButtonItem1 */
        /*  */
        this-object:barButtonItem1:Caption = "Export to PDF".
        this-object:barButtonItem1:Id = 37.
        this-object:barButtonItem1:Name = "barButtonItem1".
        /*  */
        /* biExportToText */
        /*  */
        this-object:biExportToText:Caption = "Export to Text".
        this-object:biExportToText:Glyph = cast(resources:GetObject("biExportToText.Glyph"), System.Drawing.Image).
        this-object:biExportToText:Id = 41.
        this-object:biExportToText:Name = "biExportToText".
        this-object:biExportToText:ItemClick:Subscribe(this-object:biExportToText_ItemClick).
        /*  */
        /* ribbonGalleryBarItem1 */
        /*  */
        this-object:ribbonGalleryBarItem1:Caption = "ribbonGalleryBarItem1".
        this-object:ribbonGalleryBarItem1:Id = 42.
        this-object:ribbonGalleryBarItem1:Name = "ribbonGalleryBarItem1".
        this-object:ribbonGalleryBarItem1:GalleryItemClick:Subscribe(this-object:ribbonGalleryBarItem1_GalleryItemClick).
        /*  */
        /* ribbonPage1 */
        /*  */
        @VisualDesigner.FormMember (NeedsInitialize="false", InitializeArray="true").
        define variable arrayvar4 as DevExpress.XtraBars.Ribbon.RibbonPageGroup extent 4 no-undo.
        arrayvar4[1] = this-object:ribbonPageGroup2.
        arrayvar4[2] = this-object:ribbonPageGroup1.
        arrayvar4[3] = this-object:ribbonPageGroup3.
        arrayvar4[4] = this-object:ribbonPageGroup4.
        this-object:ribbonPage1:Groups:AddRange(arrayvar4).
        this-object:ribbonPage1:Name = "ribbonPage1".
        this-object:ribbonPage1:Text = "Home".
        /*  */
        /* ribbonPageGroup2 */
        /*  */
        this-object:ribbonPageGroup2:ItemLinks:Add(this-object:bbiAdd).
        this-object:ribbonPageGroup2:ItemLinks:Add(this-object:bbiEdit).
        this-object:ribbonPageGroup2:ItemLinks:Add(this-object:bbiDelete).
        this-object:ribbonPageGroup2:ItemLinks:Add(this-object:bbiRefresh, true).
        this-object:ribbonPageGroup2:ItemLinks:Add(this-object:bbiDisplayStyle, true, "", "", true).
        this-object:ribbonPageGroup2:Name = "ribbonPageGroup2".
        this-object:ribbonPageGroup2:ShowCaptionButton = false.
        this-object:ribbonPageGroup2:Text = "Salesrep Management".
        /*  */
        /* ribbonPageGroup1 */
        /*  */
        this-object:ribbonPageGroup1:ItemLinks:Add(this-object:bbiUp).
        this-object:ribbonPageGroup1:ItemLinks:Add(this-object:bbiDown).
        this-object:ribbonPageGroup1:Name = "ribbonPageGroup1".
        this-object:ribbonPageGroup1:ShowCaptionButton = false.
        this-object:ribbonPageGroup1:Text = "Navigation".
        /*  */
        /* ribbonPageGroup3 */
        /*  */
        this-object:ribbonPageGroup3:ItemLinks:Add(this-object:bbiPrintPreview).
        this-object:ribbonPageGroup3:ItemLinks:Add(this-object:siExport).
        this-object:ribbonPageGroup3:Name = "ribbonPageGroup3".
        this-object:ribbonPageGroup3:ShowCaptionButton = false.
        this-object:ribbonPageGroup3:Text = "Print and Export".
        /*  */
        /* ribbonPageGroup4 */
        /*  */
        this-object:ribbonPageGroup4:ItemLinks:Add(this-object:ribbonGalleryBarItem1).
        this-object:ribbonPageGroup4:Name = "ribbonPageGroup4".
        this-object:ribbonPageGroup4:Text = "ribbonPageGroup4".
        /*  */
        /* gridControl1 */
        /*  */
        this-object:gridControl1:datasource= this-object:bindingSource1.
        this-object:gridControl1:Dock = System.Windows.Forms.DockStyle:Fill.
        gridLevelNode1:RelationName = "Level1".
        @VisualDesigner.FormMember (NeedsInitialize="false", InitializeArray="true").
        define variable arrayvar5 as DevExpress.XtraGrid.GridLevelNode extent 1 no-undo.
        arrayvar5[1] = gridLevelNode1.
        this-object:gridControl1:LevelTree:Nodes:AddRange(arrayvar5).
        this-object:gridControl1:Location = new System.Drawing.Point(0, 145).
        this-object:gridControl1:MainView = this-object:cardView1.
        this-object:gridControl1:Name = "gridControl1".
        this-object:gridControl1:Size = new System.Drawing.Size(1124, 438).
        this-object:gridControl1:TabIndex = 5.
        @VisualDesigner.FormMember (NeedsInitialize="false", InitializeArray="true").
        define variable arrayvar6 as DevExpress.XtraGrid.Views.Base.BaseView extent 2 no-undo.
        arrayvar6[1] = this-object:cardView1.
        arrayvar6[2] = this-object:gridView1.
        this-object:gridControl1:ViewCollection:AddRange(arrayvar6).
        this-object:gridControl1:DoubleClick:Subscribe(this-object:gridControl1_DoubleClick).
        /*  */
        /* bindingSource1 */
        /*  */
        this-object:bindingSource1:MaxDataGuess = 0.
        this-object:bindingSource1:NoLOBs = false.
        this-object:bindingSource1:TableSchema = ?.
        /*  */
        /* cardView1 */
        /*  */
        this-object:cardView1:CardCaptionFormat = "~{1~} details".
        this-object:cardView1:FocusedCardTopFieldIndex = 0.
        this-object:cardView1:GridControl = this-object:gridControl1.
        this-object:cardView1:Name = "cardView1".
        this-object:cardView1:OptionsBehavior:Editable = false.
        this-object:cardView1:OptionsView:ShowCardExpandButton = false.
        this-object:cardView1:VertScrollVisibility = DevExpress.XtraGrid.Views.Base.ScrollVisibility:Auto.
        /*  */
        /* gridView1 */
        /*  */
        this-object:gridView1:Appearance:EvenRow:BackColor = System.Drawing.Color:LemonChiffon.
        this-object:gridView1:Appearance:EvenRow:Options:UseBackColor = true.
        this-object:gridView1:BorderStyle = DevExpress.XtraEditors.Controls.BorderStyles:Simple.
        this-object:gridView1:GridControl = this-object:gridControl1.
        this-object:gridView1:Name = "gridView1".
        this-object:gridView1:OptionsBehavior:Editable = false.
        this-object:gridView1:OptionsNavigation:EnterMoveNextColumn = true.
        this-object:gridView1:OptionsView:EnableAppearanceEvenRow = true.
        this-object:gridView1:OptionsView:EnableAppearanceOddRow = true.
        this-object:gridView1:OptionsView:ShowGroupPanel = false.
        /*  */
        /* SalesrepBaseRibbon */
        /*  */
        this-object:ClientSize = new System.Drawing.Size(1124, 583).
        this-object:Controls:Add(this-object:gridControl1).
        this-object:Controls:Add(this-object:ribbonControl1).
        this-object:Name = "BaseRibbon".
        this-object:Ribbon = this-object:ribbonControl1.
        this-object:Text = "Salesrep Management".
        THIS-OBJECT:colRepName  = NEW DevExpress.XtraGrid.Columns.GridColumn().
        THIS-OBJECT:colRepName1 = NEW DevExpress.XtraGrid.Columns.GridColumn().
        THIS-OBJECT:colSalesRep  = NEW DevExpress.XtraGrid.Columns.GridColumn().
        THIS-OBJECT:colSalesRep1 = NEW DevExpress.XtraGrid.Columns.GridColumn().
@VisualDesigner.FormMember (NeedsInitialize="false", InitializeArray="true").
DEFINE VARIABLE arrayvar9 AS DevExpress.XtraGrid.Columns.GridColumn EXTENT 2 NO-UNDO.
arrayvar9[1] = THIS-OBJECT:colRepName.
arrayvar9[2] = THIS-OBJECT:colSalesRep.
THIS-OBJECT:cardView1:Columns:AddRange(arrayvar9).
/*  */
/* colSalesRep1 */
/*  */
THIS-OBJECT:colSalesRep1:Caption = "SalesRep".
THIS-OBJECT:colSalesRep1:FieldName = "Sales-Rep".
THIS-OBJECT:colSalesRep1:Name = "colSalesRep1".
THIS-OBJECT:colSalesRep1:Visible = FALSE.
THIS-OBJECT:colSalesRep1:VisibleIndex = -1.
/*  */
/* colRepName1 */
/*  */
THIS-OBJECT:colRepName1:Caption = "RepName".
THIS-OBJECT:colRepName1:FieldName = "Rep-Name".
THIS-OBJECT:colRepName1:Name = "colRepName1".
THIS-OBJECT:colRepName1:Visible = TRUE.
THIS-OBJECT:colRepName1:VisibleIndex = 1.
@VisualDesigner.FormMember (NeedsInitialize="false", InitializeArray="true").
DEFINE VARIABLE arrayvar10 AS DevExpress.XtraGrid.Columns.GridColumn EXTENT 2 NO-UNDO.
arrayvar10[1] = THIS-OBJECT:colRepName1.
arrayvar10[2] = THIS-OBJECT:colSalesRep1.
THIS-OBJECT:gridView1:Columns:AddRange(arrayvar10).
/*  */
/* colSalesRep */
/*  */
THIS-OBJECT:colSalesRep:Caption = "SalesRep".
THIS-OBJECT:colSalesRep:FieldName = "Sales-Rep".
THIS-OBJECT:colSalesRep:Name = "colSalesRep".
THIS-OBJECT:colSalesRep:Visible = FALSE.
THIS-OBJECT:colSalesRep:VisibleIndex = -1.
/*  */
/* colRepName */
/*  */
THIS-OBJECT:colRepName:Caption = "RepName".
THIS-OBJECT:colRepName:FieldName = "Rep-Name".
THIS-OBJECT:colRepName:Name = "colRepName".
THIS-OBJECT:colRepName:Visible = TRUE.
THIS-OBJECT:colRepName:VisibleIndex = 1.
@VisualDesigner.FormMember (NeedsInitialize="false", InitializeArray="true").
def var arrayvar7 AS "Progress.Data.TableDesc[]" NO-UNDO.
arrayvar7 = NEW "Progress.Data.TableDesc[]"(0).
DEFINE VARIABLE tableDesc1 AS Progress.Data.TableDesc NO-UNDO.
tableDesc1 = NEW Progress.Data.TableDesc("Salesrep").
tableDesc1:ChildTables = arrayvar7.
@VisualDesigner.FormMember (NeedsInitialize="false", InitializeArray="true").
DEFINE VARIABLE arrayvar8 AS Progress.Data.ColumnPropDesc EXTENT 2 NO-UNDO.
arrayvar8[1] = new Progress.Data.ColumnPropDesc("Sales-Rep", "SalesRep", Progress.Data.DataType:Character).
arrayvar8[2] = new Progress.Data.ColumnPropDesc("Rep-Name", "RepName", Progress.Data.DataType:Character).
tableDesc1:Columns = arrayvar8.
THIS-OBJECT:bindingSource1:TableSchema = tableDesc1.
THIS-OBJECT:Load:Subscribe(THIS-OBJECT:Salesrep_Load).
        cast(this-object:ribbonControl1, System.ComponentModel.ISupportInitialize):EndInit().
        cast(this-object:applicationMenu1, System.ComponentModel.ISupportInitialize):EndInit().
        cast(this-object:gridControl1, System.ComponentModel.ISupportInitialize):EndInit().
        cast(this-object:bindingSource1, System.ComponentModel.ISupportInitialize):EndInit().
        cast(this-object:cardView1, System.ComponentModel.ISupportInitialize):EndInit().
        cast(this-object:gridView1, System.ComponentModel.ISupportInitialize):EndInit().
        this-object:ResumeLayout(false).
        catch e as Progress.Lang.Error:
            undo, throw e.
        end catch.
	end method.


  method protected void DataRefresh(p_Object as sports.Model.Salesrep):
    bindingSource1:Refresh().
  end method.


  method protected void ItemClicked(p_Key as char):
    case p_Key:
      when "new"       then NewPressed().
      when "update"    then UpdatePressed().
      when "Remove"    then RemovePressed().
      when "Up"        then MovePrev().
      when "Down"      then MoveNext().
      when "ShowGrid"  then this-object:gridControl1:MainView = this-object:gridView1. 
      when "ShowCards" then this-object:gridControl1:MainView = this-object:cardView1. 
      
      otherwise message "Feature not yet implemented" view-as alert-box information.
    end case.
  end method.
  

  method protected sports.Model.Salesrep GetItem():
    case gridControl1:MainView:Name:
      when "gridView1" then return (new sports.Model.Salesrep()):find(string(gridview1:GetRowCellValue(gridView1:FocusedRowHandle,"Sales-Rep"))).
      when "cardView1" then return (new sports.Model.Salesrep()):find(string(cardView1:GetRowCellValue(cardView1:FocusedRowHandle,"Sales-Rep"))).
    end case.    
  end method.
  
  method protected void MoveNext():
    case gridControl1:MainView:Name:
      when "gridView1" then gridview1:MoveNext().
      when "cardView1" then cardView1:MoveNext().
    end case.    
  end method.

  method protected void MovePrev():
    case gridControl1:MainView:Name:
      when "gridView1" then gridview1:MovePrev().
      when "cardView1" then cardView1:MovePrev().
    end case.    
  end method.

  method protected void RemovePressed():
    message "Are you sure that you want to remove this Record"
            view-as alert-box question buttons yes-no update lv_ok as logical.
            
    if not lv_ok then return.
    
    GetItem():Remove().            

  end method.

  method protected void NewPressed():
    (new sports.UI.winform.Update.SalesrepUpdate(new sports.Model.Salesrep())):Show().
  end method.


	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	method private void ribbonGalleryBarItem1_GalleryItemClick( input sender as System.Object, input e as DevExpress.XtraBars.Ribbon.GalleryItemClickEventArgs ):
	   dotr.Maia.UI.Library.Skin:Instance:CurrentSkin = e:Item:Caption.
	   return.
	end method.


  method protected void UpdatePressed():
    (new sports.UI.winform.Update.SalesrepUpdate(GetItem())):Show().
  end method.

	destructor public SalesrepBaseRibbon ( ):

    Stomp1:NewMessage:Unsubscribe(NewStompMessage).
    
    delete object Stomp1.
    
		if valid-object(components) then do:
			cast(components, System.IDisposable):Dispose().
		end.

	end destructor.

end class.
@BuildInfo(Source="./sports/_Maia-Config/Salesrep/_Config.xml").
@BuildInfo(Date="30/08/2011 18:47:32.357+01:00").