
/*
Copyright (C) 2011 by Julian Lyndon-Smith (julian+mit@dotr.com)

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS for A PARTICULAR PURPOSE and NONINFRINGEMENT. IN no EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE for ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR otherwise, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
*/

/* $Id$ */

using Progress.Lang.*.
using Progress.Windows.Form.
using dotr.Maia.*.

routine-level on error undo, throw.

class sports.UI.winform.Update.Base.SalesrepBaseUpdate inherits dotr.Maia.UI.winform.dotrForm: 
	
	define private variable components as System.ComponentModel.IContainer no-undo.

  def protected var Salesrep1 as sports.Model.Salesrep no-undo.
  
  define protected variable groupControl1 as DevExpress.XtraEditors.GroupControl no-undo.
  define protected variable simpleButton2 as DevExpress.XtraEditors.SimpleButton no-undo.
  define protected variable simpleButton1 as DevExpress.XtraEditors.SimpleButton no-undo.
  def protected var uiRepName as DevExpress.XtraEditors.TextEdit no-undo.
  def protected var labelRepName as DevExpress.XtraEditors.LabelControl no-undo.
  def protected var uiSalesRep as DevExpress.XtraEditors.TextEdit no-undo.
  def protected var labelSalesRep as DevExpress.XtraEditors.LabelControl no-undo.
  
  define protected variable Update_Fill_Panel as System.Windows.Forms.Panel no-undo.
  
	constructor public SalesrepBaseUpdate (p_Salesrep as sports.Model.Salesrep  ):
	  super().
    InitializeComponent().
    assign Salesrep1 = p_Salesrep.
    
    catch e as Progress.Lang.Error:
      undo, throw e.
    end catch.

	end constructor.

  constructor public SalesrepBaseUpdate ():
    super().
    InitializeComponent().
    
    catch e as Progress.Lang.Error:
      undo, throw e.
    end catch.

  end constructor.


	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	method private void BaseUpdate_FormClosed( input sender as System.Object, input e as System.Windows.Forms.FormClosedEventArgs ):
		shutdown().
		return.

	end method.

	method private void InitializeComponent(  ):
		THIS-OBJECT:uiRepName = NEW DevExpress.XtraEditors.TextEdit().
  THIS-OBJECT:labelRepName = NEW DevExpress.XtraEditors.LabelControl().
  THIS-OBJECT:uiSalesRep = NEW DevExpress.XtraEditors.TextEdit().
  THIS-OBJECT:labelSalesRep = NEW DevExpress.XtraEditors.LabelControl().
		 
    /* NOTE: The following method is automatically generated.
    
    We strongly suggest that the contents of this method only be modified using the
    Visual Designer to avoid any incompatible modifications.
    
    Modifying the contents of this method using a code editor will invalidate any support for this file. */
    this-object:Update_Fill_Panel = new System.Windows.Forms.Panel().
    this-object:simpleButton2 = new DevExpress.XtraEditors.SimpleButton().
    this-object:simpleButton1 = new DevExpress.XtraEditors.SimpleButton().
    this-object:groupControl1 = new DevExpress.XtraEditors.GroupControl().
    this-object:Update_Fill_Panel:SuspendLayout().
    cast(this-object:groupControl1, System.ComponentModel.ISupportInitialize):BeginInit().
    this-object:SuspendLayout().
    /*  */
    /* Update_Fill_Panel */
    /*  */
    this-object:Update_Fill_Panel:Controls:Add(this-object:simpleButton2).
    this-object:Update_Fill_Panel:Controls:Add(this-object:simpleButton1).
    this-object:Update_Fill_Panel:Controls:Add(this-object:groupControl1).
    this-object:Update_Fill_Panel:Cursor = System.Windows.Forms.Cursors:Default.
    this-object:Update_Fill_Panel:Dock = System.Windows.Forms.DockStyle:Fill.
    this-object:Update_Fill_Panel:Location = new System.Drawing.Point(0, 0).
    this-object:Update_Fill_Panel:Name = "Update_Fill_Panel".
    this-object:Update_Fill_Panel:Size = new System.Drawing.Size(665, 461).
    this-object:Update_Fill_Panel:TabIndex = 0.
    /*  */
    /* simpleButton2 */
    /*  */
    this-object:simpleButton2:DialogResult = System.Windows.Forms.DialogResult:Cancel.
    this-object:simpleButton2:Location = new System.Drawing.Point(578, 426).
    this-object:simpleButton2:Name = "simpleButton2".
    this-object:simpleButton2:Size = new System.Drawing.Size(75, 23).
    this-object:simpleButton2:TabIndex = 21.
    this-object:simpleButton2:Text = "C&ancel".
    this-object:simpleButton2:Click:Subscribe(this-object:simpleButton2_Click).
    /*  */
    /* simpleButton1 */
    /*  */
    this-object:simpleButton1:DialogResult = System.Windows.Forms.DialogResult:OK.
    this-object:simpleButton1:Location = new System.Drawing.Point(497, 426).
    this-object:simpleButton1:Name = "simpleButton1".
    this-object:simpleButton1:Size = new System.Drawing.Size(75, 23).
    this-object:simpleButton1:TabIndex = 20.
    this-object:simpleButton1:Text = "&Save".
    this-object:simpleButton1:Click:Subscribe(this-object:simpleButton1_Click).
    /*  */
    /* groupControl1 */
    /*  */
    this-object:groupControl1:Location = new System.Drawing.Point(12, 12).
    this-object:groupControl1:Name = "groupControl1".
    this-object:groupControl1:ShowCaption = false.
    this-object:groupControl1:Size = new System.Drawing.Size(643, 399).
    this-object:groupControl1:TabIndex = 8.
    THIS-OBJECT:groupControl1:Controls:Add(THIS-OBJECT:uiRepName).
    THIS-OBJECT:groupControl1:Controls:Add(THIS-OBJECT:labelRepName).
    THIS-OBJECT:groupControl1:Controls:Add(THIS-OBJECT:uiSalesRep).
    THIS-OBJECT:groupControl1:Controls:Add(THIS-OBJECT:labelSalesRep).
THIS-OBJECT:groupControl1:Text = "groupControl1".
CAST(THIS-OBJECT:uiRepName:Properties, System.ComponentModel.ISupportInitialize):BeginInit().
CAST(THIS-OBJECT:uiSalesRep:Properties, System.ComponentModel.ISupportInitialize):BeginInit().
/*  */
/* uiSalesRep */
/*  */
THIS-OBJECT:uiSalesRep:Location = NEW System.Drawing.Point(63, 9).
THIS-OBJECT:uiSalesRep:Name = "SalesRep".
THIS-OBJECT:uiSalesRep:Size = NEW System.Drawing.Size(100, 20).
THIS-OBJECT:uiSalesRep:TabIndex = 3.
/*  */
/* labelSalesRep */
/*  */
THIS-OBJECT:labelSalesRep:AutoSizeMode = DevExpress.XtraEditors.LabelAutoSizeMode:Horizontal.
THIS-OBJECT:labelSalesRep:Location = NEW System.Drawing.Point(12, 10).
THIS-OBJECT:labelSalesRep:Name = "labelSalesRep".
THIS-OBJECT:labelSalesRep:Size = NEW System.Drawing.Size(26, 13).
THIS-OBJECT:labelSalesRep:TabIndex = 2.
THIS-OBJECT:labelSalesRep:Text = "SalesRep:".
/*  */
/* uiRepName */
/*  */
THIS-OBJECT:uiRepName:Location = NEW System.Drawing.Point(63, 35).
THIS-OBJECT:uiRepName:Name = "RepName".
THIS-OBJECT:uiRepName:Size = NEW System.Drawing.Size(300, 20).
THIS-OBJECT:uiRepName:TabIndex = 5.
/*  */
/* labelRepName */
/*  */
THIS-OBJECT:labelRepName:AutoSizeMode = DevExpress.XtraEditors.LabelAutoSizeMode:Horizontal.
THIS-OBJECT:labelRepName:Location = NEW System.Drawing.Point(10, 36).
THIS-OBJECT:labelRepName:Name = "labelRepName".
THIS-OBJECT:labelRepName:Size = NEW System.Drawing.Size(26, 13).
THIS-OBJECT:labelRepName:TabIndex = 4.
THIS-OBJECT:labelRepName:Text = "RepName:".

    /*  */
    /* SalesrepBaseUpdate */
    /*  */
    this-object:CancelButton = this-object:simpleButton2.
    this-object:ClientSize = new System.Drawing.Size(665, 461).
    this-object:Controls:Add(this-object:Update_Fill_Panel).
    this-object:FormBorderStyle = System.Windows.Forms.FormBorderStyle:FixedDialog.
    this-object:LookAndFeel:SkinName = "Office 2010 Blue".
    this-object:LookAndFeel:UseDefaultLookAndFeel = false.
    this-object:Name = "BaseUpdate".
    this-object:SizeGripStyle = System.Windows.Forms.SizeGripStyle:Hide.
    
    this-object:Load:Subscribe(this-object:SalesrepUpdate_Load).
    this-object:FormClosed:Subscribe(this-object:BaseUpdate_FormClosed).
    this-object:Update_Fill_Panel:ResumeLayout(false).
    cast(this-object:groupControl1, System.ComponentModel.ISupportInitialize):EndInit().
    CAST(THIS-OBJECT:uiRepName:Properties, System.ComponentModel.ISupportInitialize):EndInit().
    CAST(THIS-OBJECT:uiSalesRep:Properties, System.ComponentModel.ISupportInitialize):EndInit().
THIS-OBJECT:ResumeLayout(FALSE).
    catch e as Progress.Lang.Error:
      undo, throw e.
    end catch.
	end method.


	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	method private void SalesrepUpdate_Load( input sender as System.Object, input e as System.EventArgs ):

	  if not valid-object(Salesrep1) then return.
    
    assign uiRepName:text  = Salesrep1:RepName
           uiSalesRep:text = Salesrep1:SalesRep.
    
		return.

	end method.

	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	method protected void simpleButton1_Click( input sender as System.Object, input e as System.EventArgs ):
	  this-object:Save().
  end method.
  
  method protected void Save():		
           
    assign Salesrep1:RepName  = uiRepName:Text
           Salesrep1:SalesRep = uiSalesRep:Text.
    
    do transaction on error undo, leave:
		  Salesrep1:Save().

      catch f as Progress.Lang.AppError:
        case f:GetMessageNum(1):
          otherwise message substitute ("Cannot save Salesrep [&1]",f:GetMessage(1)) view-as alert-box warning.
        end case.
       
        return .   
      end catch.
    end.
		
		this-object:DialogResult = System.Windows.Forms.DialogResult:OK.
    this-object:Close ( ).
    
		return.

	end method.


  method private void shutdown():
    this-object:DialogResult = System.Windows.Forms.DialogResult:Cancel.
    delete object this-object.
    return.
  end method.

	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	method private void simpleButton2_Click( input sender as System.Object, input e as System.EventArgs ):
    this-object:Close().
		return.

	end method.
    
  destructor public SalesrepBaseUpdate ( ):

		if valid-object(components) then do:
			cast(components, System.IDisposable):Dispose().
		end.

	end destructor.

end class.
@BuildInfo(Source="./sports/_Maia-Config/Salesrep/_Config.xml").
@BuildInfo(Date="30/08/2011 08:58:04.830+01:00").